#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <time.h>
#include <limits.h>
#include <signal.h>
#include <stdlib.h>
#include <ctype.h>
#include <unistd.h>
#include <errno.h>
#include "config.h"
#include "mem.h"
#include "io.h"
#include "jupe.h"

static int sockserv;		/* server socket */

int die(char *s)
{
    exit(0);
}

void connect_me(char *server, char *reason, int type)
{
    sockserv = SockOpen(SERVER_NAME, SERVER_PORT);

    if (sockserv < 0)
    {
	exit(1);
    }
    if (type == TYPE_IRCNET)
    {
	SockPrintf(sockserv, "PASS %s 0210030002 IRC:abIHw P\r\n",
	       SERVER_PASS);
	SockPrintf(sockserv, "SERVER %s 1 :IRCNet jupe server\r\n",
	       JUPITER_NAME);

#ifdef BLIND_SQUIT
	SockPrintf(sockserv, ":%s SQUIT %s :\002JUPED\002: %s\r\n",
		JUPITER_NAME, server, reason);
#endif

	SockPrintf(sockserv,
	       "SERVER %s 2 2 :\002JUPED\002: %s\r\n", 
	       server, reason);
    }
    else if (type == TYPE_EFNET)
    {
	SockPrintf(sockserv, "PASS %s :TS\r\n", SERVER_PASS);
        SockPrintf(sockserv, "CAPAB QS\r\n");
	SockPrintf(sockserv, "SERVER %s 1 :EFNet jupe server\r\n",
		JUPITER_NAME);

#ifdef BLIND_SQUIT
	SockPrintf(sockserv, ":%s SQUIT %s :\002JUPED\002: %s\r\n",
		JUPITER_NAME, server, reason);
#endif

	SockPrintf(sockserv, "SERVER %s 2 :\002JUPED\002: %s\r\n",
		server, reason);
    }
#ifdef WALLOPS
    SockPrintf(sockserv, ":%s WALLOPS :\002JUPED\002: %s: %s\r\n",
		server, server, reason);
#endif
}

void communicate(char *server, char *reason)
{
    int rcvd, i;
    int done;
    char cbuf[513];
    char *param[15];
    char *token;

    rcvd = 0;
    while (rcvd != -1)
    {
	rcvd = SockRead(sockserv, cbuf, sizeof(cbuf));
	param[0] = cbuf;
	done = 0;

	for (token = cbuf, i = 0; token && i < 15; token++)
	{
	    if (*token == '\n' || *token == '\r')
	    {
		*token = 0;
		break;
	    }
	    if (!done && *token == ' ')
	    {
		*token = 0;
		i++;
		param[i] = token + 1;
		if (*param[i] == ':')
		{
		    param[i]++;
		    done = 1;
		}
	    }
	}
	for (i++; i < 15; i++)
	    param[i] = NULL;
	if (!strcmp(param[0], "PING"))
	    SockPrintf(sockserv, "PONG :%s\r\n", param[1]);

	if (!strcmp(param[1], "SQUIT"))
	{
		if (!strcasecmp(param[2],server))
		{
#ifndef PERSIST
#ifdef WALLOPS
			SockPrintf(sockserv,":%s WALLOPS :Received SQUIT, dying...\r\n",server);
#endif
			SockPrintf(sockserv,"ERROR :End of jupe\r\n");
			exit(1);
#else
			SockPrintf(sockserv, "SERVER %s 1 :\002JUPED\002: %s\r\n",
				server, reason);
#ifdef WALLOPS
			SockPrintf(sockserv, ":%s WALLOPS :\002JUPED\002: %s %s\r\n",
				server, server, reason);
#endif
#endif
		}
	}
    }
}



int main(int argc, char *argv[])
{
    int type = TYPE_IRCNET;
    char *server, *reason;
    
    if (argc < 2)
    {
	printf("%s [-i|-e] <server-to-jupe> \"[reason]\"\n", argv[0]);
	exit(5);
    }
    if (argv[1][0] == '-')
    {
        if ( (argv[1][1] == 'i') || (argv[1][1] == 'I') )
		type = TYPE_IRCNET;
        else if ( (argv[1][1] == 'e') || (argv[1][1] == 'E') )
		type = TYPE_EFNET;
	else
	{
		printf("%s: Invalid parameter: %s", argv[0], argv[1]);
		exit(6);
	}
	server = argv[2];
	reason = argv[3];
    }
    else
    {
	server = argv[1];
	reason = argv[2];
    }
    
    switch (fork())
    {
    case -1:
	perror("fork()");
	exit(3);
    case 0:
	close(STDIN_FILENO);
	close(STDOUT_FILENO);
	close(STDERR_FILENO);
	if (setsid() == -1)
	    exit(4);
	break;
    default:
	printf("daemonized.\n");
	return 0;
    }
    for (;;)
    {
	connect_me(server,reason, type);
	communicate(server,reason);
	sleep(RECONNECT_DELAY);
    }
    return 0;
}
